package prezentobiorcy;

import prezenty.Prezent;
import prezenty.KategoriaPrezentu;

import java.util.ArrayList;

public abstract class AbstrPrezentobiorca implements Prezentobiorca {
    protected int limit_prezentów;
    protected int ile_rózg;
    protected ArrayList<Prezent> otrzymane_prezenty;

    AbstrPrezentobiorca(int limit_prezentów) {
        this.limit_prezentów = limit_prezentów;
        otrzymane_prezenty = new ArrayList<>();
    }

    public boolean otrzymajPrezent(Prezent prezent) {
        if (prezent.kategoriaPrezentu() == KategoriaPrezentu.Rózga) {
            ile_rózg++;
            return true;
        }
        if (otrzymane_prezenty.size() >= limit_prezentów) {
            return false;
        } else {
            otrzymane_prezenty.add(prezent);
            return true;
        }
    }

    public abstract boolean zadowolony();

    protected abstract String nazwa();

    @Override
    public String toString() {
        String s = nazwa() + "{ileRazyRózgi=" + ile_rózg + ",ilePrezentów=" + otrzymane_prezenty.size() + ":[";
        for (int i = 0; i < otrzymane_prezenty.size(); i++) {
            if (i > 0) {
                s += ", ";
            }
            s += otrzymane_prezenty.get(i);
        }
        s += "]}";
        return s;
    }

}