package prezenty;

import java.util.Random;

public class Prezent {
    protected String nazwa;
    public final KategoriaPrezentu kategoria;

    public KategoriaPrezentu kategoriaPrezentu() {
        return kategoria;
    }

    private static Random rnd = new Random();

    public Prezent(String nazwa, KategoriaPrezentu k) {
        this.nazwa = nazwa;
        this.kategoria = k;
    }

    public static Prezent losowyPrezent() {
        switch (rnd.nextInt() % 3) {
            case 0:
                return losowyPrezent(KategoriaPrezentu.Książki);
            case 1:
                return losowyPrezent(KategoriaPrezentu.Inne);
            default:
                return losowyPrezent(KategoriaPrezentu.Rózga);

        }
    }

    public String toString() {
        return "" + kategoria + "(" + nazwa + ")";
    }

    public static Prezent losowyPrezent(KategoriaPrezentu k) {
        switch (k) {
            case Książki:
                return Ksiazka.losowaKsiazka();
            case Inne:
                return Skarpetki.losoweSkarpetki();
            default:
                return Rozga.daj();
        }
    }

    public static void main(String args[]) {
        Prezent p = Prezent.losowyPrezent();
        System.out.println("p=" + p);
    }
}